"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styled_components_1 = require("styled-components");
const swipeableStyledListItem_1 = __importDefault(require("./swipeableStyledListItem"));
const react_swipeable_list_1 = require("react-swipeable-list");
const state_1 = require("./state");
const util_1 = require("../Action/util");
const Animation_1 = __importDefault(require("../../Loading/Animation"));
const styles_1 = require("../../Loading/Animation/styles");
const ListItem = (props) => {
    // console.log('Product props', props);
    const [state, setState] = (0, react_usestateref_1.default)(state_1.State.NONE);
    const [_lastState, setLastState] = (0, react_usestateref_1.default)(state_1.State.NONE);
    const [index, setIndex] = (0, react_usestateref_1.default)(undefined);
    const [_lastIndex, setLastIndex] = (0, react_usestateref_1.default)(undefined);
    const [type, _setType] = (0, react_usestateref_1.default)(props.type);
    const [fullSwipe, _setFullSwipe] = (0, react_usestateref_1.default)(props.fullSwipe);
    const [threshold, _setThreshold] = (0, react_usestateref_1.default)(props?.threshold || 0.3);
    const [holdThreshold, _setHoldThreshold] = (0, react_usestateref_1.default)(props?.holdThreshold || 1);
    const [holdTimeout, setHoldTimeout] = (0, react_usestateref_1.default)(undefined);
    (0, react_1.useEffect)(() => { }, [props.search, props?.setSearch]);
    const actionSwipeStart = () => {
        setState(state_1.State.NONE);
    };
    const remapActionsProps = (actions, state) => {
        return react_1.default.Children.map?.(actions, (action, index) => {
            if (action && state) {
                const newProps = {
                    ...action.props,
                    onClick: (...args) => {
                        const currentIndex = index;
                        const currentState = state;
                        const lastIndex = currentIndex;
                        const lastState = currentState;
                        (0, util_1.baseAction)(state, setState, setLastState, index, setIndex, setLastIndex, action.props?.onClick, ...args, currentState, currentIndex, lastState, lastIndex);
                    },
                };
                const cloneChild = react_1.default.cloneElement(action, newProps);
                return cloneChild;
            }
            return undefined;
        });
    };
    const leadingActions = () => {
        const actions = remapActionsProps(props.leadings, state_1.State.LEADING);
        return actions && actions?.length > 0 ? (react_1.default.createElement(react_swipeable_list_1.LeadingActions, null, actions)) : undefined;
    };
    const trailingActions = () => {
        const actions = remapActionsProps(props.trailings, state_1.State.TRAILING);
        return actions && actions?.length > 0 ? (react_1.default.createElement(react_swipeable_list_1.TrailingActions, null, actions)) : undefined;
    };
    const changeState = (newState) => {
        setLastState(state);
        setState(newState);
    };
    const item = (
    // @ts-ignore
    react_1.default.createElement(swipeableStyledListItem_1.default, { key: props.key, blockSwipe: false, type: type, listType: type, fullSwipe: fullSwipe, threshold: threshold, scrollStartThreshold: 50, leadingActions: leadingActions(), trailingActions: trailingActions(), onSwipeStart: actionSwipeStart },
        react_1.default.createElement("div", { style: { width: '100%', boxSizing: 'border-box' }, onMouseUp: (event) => {
                // console.log('Mouse up');
                clearTimeout(holdTimeout);
                setHoldTimeout(undefined);
                let result;
                if (state == state_1.State.HOLD) {
                    if (props?.onHold != undefined)
                        result = props?.onHold(state, index, event);
                }
                else {
                    if (props?.onClick != undefined)
                        result = props?.onClick(state, index, event);
                }
                changeState(state_1.State.CLICK);
                // console.log('State', State[state]);
                return result;
            }, onMouseDown: () => {
                // console.log('Mouse down');
                setHoldTimeout(setTimeout(() => {
                    changeState(state_1.State.HOLD);
                }, 1000 * holdThreshold));
            } }, props.children)));
    return state == state_1.State.HOLD ? (react_1.default.createElement(Animation_1.default, { crude: true, Animation: (0, styled_components_1.withTheme)(styles_1.Hitting), style: { width: '100%' } }, item)) : (react_1.default.createElement(react_1.default.Fragment, null, item));
};
exports.default = (0, styled_components_1.withTheme)(ListItem);
//# sourceMappingURL=index.js.map